%{
/*
   This file is part of the index package,
   Copyright (C) 1997 Harold Tay, haroldtay@pacific.net.sg

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA
 */
/* Scanner to get words from an html document.
 */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/stat.h>
#include <ctype.h>

extern void putword(char *);
int max_word_length = 15;
int min_word_length = 2;
int start_words = 0;

%}

%x COMMENT NAME

tag  (^.[a-z]+)|(\\f.)
word [a-z0-9_]+
contraction [a-z]+'[ts]

%%

.|\n                     ;
<INITIAL>{tag}           ;
{contraction}            ;

<INITIAL>^\.SH\ *NAME\ *\n  {
                           BEGIN(NAME);
                         }
<NAME>\n                 {
                           BEGIN(INITIAL);
                         }
<NAME>^.*$               {
                           fprintf(stdout, "\001%s\n", yytext);
                           yyless(0);
                           start_words = 1;
                         }

<INITIAL>^\.\\\".*$      ;

<INITIAL>^\.ig           {
                           BEGIN(COMMENT);
                         }
<COMMENT>^\.\.$          {
                           BEGIN(INITIAL);
                         }
<COMMENT>.|\n            ;

<INITIAL>to ;
<INITIAL>is ;
<INITIAL>of ;
<INITIAL>in ;
<INITIAL>name ;
<INITIAL>on ;
<INITIAL>th ;
<INITIAL>or ;
<INITIAL>sh ;
<INITIAL>if ;
<INITIAL>be ;
<INITIAL>description ;
<INITIAL>by ;
<INITIAL>it ;
<INITIAL>as ;
<INITIAL>an ;
<INITIAL>synopsis ;
<INITIAL>so ;
<INITIAL>file ;
<INITIAL>no ;
<INITIAL>the ;
<INITIAL>and ;
<INITIAL>for ;
<INITIAL>you ;
<INITIAL>that ;
<INITIAL>wrote ;
<INITIAL>with ;
<INITIAL>have ;
<INITIAL>this ;
<INITIAL>com ;
<INITIAL>are ;
<INITIAL>not ;
<INITIAL>but ;
<INITIAL>can ;
<INITIAL>from ;
<INITIAL>your ;
<INITIAL>all ;
<INITIAL>one ;
<INITIAL>what ;
<INITIAL>will ;
<INITIAL>there ;
<INITIAL>would ;
<INITIAL>any ;
<INITIAL>they ;
<INITIAL>like ;
<INITIAL>was ;
<INITIAL>http ;
<INITIAL>about ;
<INITIAL>just ;
<INITIAL>has ;
<INITIAL>more ;
<INITIAL>www ;
<INITIAL>some ;
<INITIAL>out ;
<INITIAL>only ;
<INITIAL>get ;
<INITIAL>how ;
<INITIAL>know ;
<INITIAL>which ;
<INITIAL>when ;
<INITIAL>other ;
<INITIAL>use ;
<INITIAL>please ;
<INITIAL>time ;
<INITIAL>also ;
<INITIAL>then ;
<INITIAL>good ;
<INITIAL>1997 ;
<INITIAL>who ;
<INITIAL>than ;
<INITIAL>does ;
<INITIAL>them ;
<INITIAL>now ;
<INITIAL>very ;
<INITIAL>want ;
<INITIAL>need ;
<INITIAL>should ;
<INITIAL>been ;
<INITIAL>see ;
<INITIAL>could ;
<INITIAL>way ;
<INITIAL>anyone ;
<INITIAL>their ;
<INITIAL>where ;
<INITIAL>thanks ;
<INITIAL>into ;
<INITIAL>because ;
<INITIAL>here ;
<INITIAL>these ;
<INITIAL>had ;
<INITIAL>much ;
<INITIAL>why ;
<INITIAL>most ;
<INITIAL>may ;
<INITIAL>used ;
<INITIAL>many ;
<INITIAL>same ;
<INITIAL>two ;
<INITIAL>too ;
<INITIAL>first ;
<INITIAL>problem ;
<INITIAL>still ;
<INITIAL>our ;
<INITIAL>really ;
<INITIAL>over ;
<INITIAL>must ;
<INITIAL>something ;
<INITIAL>those ;
<INITIAL>were ;
<INITIAL>say ;
<INITIAL>such ;
<INITIAL>take ;
<INITIAL>his ;
<INITIAL>before ;
<INITIAL>call ;
<INITIAL>after ;
<INITIAL>looking ;
<INITIAL>try ;
<INITIAL>off ;
<INITIAL>another ;
<INITIAL>both ;
<INITIAL>since ;
<INITIAL>being ;
<INITIAL>better ;
<INITIAL>while ;
<INITIAL>through ;
<INITIAL>did ;
<INITIAL>its ;
<INITIAL>without ;
<INITIAL>etc ;
<INITIAL>thing ;
<INITIAL>got ;
<INITIAL>writes ;
<INITIAL>might ;
<INITIAL>made ;
<INITIAL>own ;
<INITIAL>going ;
<INITIAL>look ;
<INITIAL>around ;
<INITIAL>give ;
<INITIAL>following ;
<INITIAL>long ;
<INITIAL>sure ;
<INITIAL>actually ;
<INITIAL>day ;
<INITIAL>send ;
<INITIAL>few ;
<INITIAL>either ;
<INITIAL>things ;
<INITIAL>down ;
<INITIAL>put ;
<INITIAL>however ;
<INITIAL>above ;
<INITIAL>come ;
<INITIAL>anything ;
<INITIAL>said ;
<INITIAL>tell ;
<INITIAL>real ;
<INITIAL>every ;
<INITIAL>enough ;
<INITIAL>always ;
<INITIAL>again ;
<INITIAL>yes ;
<INITIAL>high ;
<INITIAL>ever ;
<INITIAL>says ;
<INITIAL>great ;
<INITIAL>let ;
<INITIAL>least ;
<INITIAL>probably ;
<INITIAL>him ;
<INITIAL>though ;
<INITIAL>yet ;
<INITIAL>seems ;
<INITIAL>check ;
<INITIAL>done ;
<INITIAL>else ;
<INITIAL>able ;
<INITIAL>keep ;
<INITIAL>possible ;
<INITIAL>under ;
<INITIAL>times ;
<INITIAL>thank ;
<INITIAL>getting ;
<INITIAL>doing ;
<INITIAL>maybe ;
<INITIAL>comes ;
<INITIAL>away ;
<INITIAL>rather ;
<INITIAL>having ;
<INITIAL>big ;
<INITIAL>written ;
<INITIAL>once ;
<INITIAL>less ;
<INITIAL>hand ;
<INITIAL>job ;
<INITIAL>next ;
<INITIAL>word ;
<INITIAL>change ;
<INITIAL>quite ;
<INITIAL>regards ;
<INITIAL>makes ;
<INITIAL>open ;
<INITIAL>seen ;

<INITIAL>{word}          {
                           putword(yytext);
                         }

%%

void
putword(char * text)
{
  char * cp;

  if( ! start_words )return;
  if( yyleng >= min_word_length && yyleng <= max_word_length ){
    for(cp = text; *cp; cp++)
      if( isupper(*cp) )*cp = tolower(*cp);
    printf("%s\n", text);
  }
}

int
yywrap(void)
{
  start_words = 0;
  return(1);
}

int
main(int argc, char ** argv)
{
  int i;
  int argstart = 1;

  for(i = 1; i < argc; i++)
    if( '-' == *argv[i] )
      if( isdigit(argv[i][1]) ){
        char * cp;
        min_word_length = atoi(&argv[i][1]);
        cp = strchr(&argv[i][1], '-');
        if( cp )max_word_length = atoi(cp + 1);
        argstart = 2;
      }else{
        fprintf(stderr, "Usage: %s [-n-m] files ...\nwhere n is the"
          " minimum word length and m is the maximum.\n", argv[0]);
        exit(1);
      }

  for(i = argstart; i < argc; i++){
    char cmdline[1024];
    struct stat st;
    char * filename;
    char * cp;

    if( -1 == stat(argv[i], &st) ){
      fprintf(stderr, "Can't stat %s\n", argv[i]);
      continue;
    }
    if( ! S_ISREG(st.st_mode) ){
      fprintf(stderr, "%s is not a regular file\n", argv[i]);
      continue;
    }

    /* get basename of file */
    if( (cp = strrchr(argv[i], '/')) )
      filename = cp + 1;
    else
      filename = argv[i];

    *cmdline = '\0';

    if( (cp = strrchr(filename, '.')) )
      if( 0 == strcmp(cp, ".gz") ){
        sprintf(cmdline, "gzip -cd %s", argv[i]);
        yyin = popen(cmdline, "r");
        *cp = '\0';
      }
    else
      yyin = fopen(argv[i], "r");

    if( ! yyin ){
      fprintf(stderr, "Can't open %s: %s\n", argv[i], strerror(errno));
      continue;
    }

    /* fprintf(stdout, "\001%s\n", filename); */

    yyrestart(yyin);
    yylex();
    if( *cmdline )pclose(yyin);
    else fclose(yyin);
  }
  exit(0);
}
